"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getGridClasses = exports.SchemaGridItem = exports.SchemaGridHandler = exports.RootRenderer = exports.GroupRenderer = void 0;
var _react = _interopRequireDefault(require("react"));
var _uiSchema = require("@ui-schema/ui-schema");
var _clsx = _interopRequireDefault(require("clsx"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var getGridClasses = exports.getGridClasses = function getGridClasses(schema) {
  var classNameArray = [];
  var view = schema ? schema.getIn(['view']) : undefined;
  if (view && view.get('sizeXs')) {
    classNameArray.push('col-' + view.get('sizeXs'));
  } else {
    classNameArray.push('col-12');
  }
  if (view && view.get('sizeSm')) {
    classNameArray.push('col-sm-' + view.get('sizeSm'));
  }
  if (view && view.get('sizeMd')) {
    classNameArray.push('col-md-' + view.get('sizeMd'));
  }
  if (view && view.get('sizeLg')) {
    classNameArray.push('col-lg-' + view.get('sizeLg'));
  }
  if (view && view.get('sizeXl')) {
    classNameArray.push('col-xl-' + view.get('sizeXl'));
  }
  return classNameArray;
};
var SchemaGridItem = exports.SchemaGridItem = function SchemaGridItem(_ref) {
  var children = _ref.children,
    schema = _ref.schema;
  return _react["default"].createElement("div", {
    className: getGridClasses(schema).join(' ')
  }, children);
};
var RootRenderer = exports.RootRenderer = function RootRenderer(props) {
  return _react["default"].createElement("div", {
    className: 'row'
  }, props.children);
};
var GroupRenderer = exports.GroupRenderer = function GroupRenderer(_ref2) {
  var children = _ref2.children;
  return _react["default"].createElement("div", {
    className: (0, _clsx["default"])('row', 'px-0')
  }, children);
};
var SchemaGridHandler = exports.SchemaGridHandler = function SchemaGridHandler(props) {
  var schema = props.schema,
    noGrid = props.noGrid,
    isVirtual = props.isVirtual;
  if (noGrid || isVirtual || schema.getIn(['view', 'noGrid'])) {
    return _react["default"].createElement(_uiSchema.NextPluginRenderer, props);
  }
  return _react["default"].createElement(SchemaGridItem, {
    schema: schema
  }, _react["default"].createElement(_uiSchema.NextPluginRenderer, props));
};