"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BoolRenderer = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactUid = require("react-uid");
var _uiSchema = require("@ui-schema/ui-schema");
var _LocaleHelperText = require("../../Component/LocaleHelperText/LocaleHelperText");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var BoolRenderer = exports.BoolRenderer = function BoolRenderer(_ref) {
  var showValidity = _ref.showValidity,
    required = _ref.required,
    errors = _ref.errors,
    value = _ref.value,
    storeKeys = _ref.storeKeys,
    _onChange = _ref.onChange,
    schema = _ref.schema;
  var id = (0, _reactUid.useUID)();
  var classForm = ['custom-control', 'custom-switch'];
  var classLabel = ['custom-control-label', 'text-light'];
  var classFormControl = ['custom-control-input'];
  if (showValidity && errors.hasError()) {
    classFormControl.push('is-invalid');
  }
  if (showValidity && !errors.hasError()) {
    classForm.push('was-validated');
  }
  var currentChecked = !!value;
  return _react["default"].createElement("div", {
    className: classForm.join(' ')
  }, _react["default"].createElement("input", {
    type: "checkbox",
    className: classFormControl.join(' '),
    id: 'uis-' + id,
    checked: currentChecked,
    required: required,
    onChange: function onChange() {
      return _onChange({
        storeKeys: storeKeys,
        scopes: ['value'],
        type: 'update',
        updater: function updater(_ref2) {
          var storeValue = _ref2.value;
          return {
            value: !storeValue
          };
        },
        schema: schema,
        required: required
      });
    }
  }), _react["default"].createElement("label", {
    className: classLabel.join(' '),
    htmlFor: 'uis-' + id
  }, _react["default"].createElement(_uiSchema.TransTitle, {
    schema: schema,
    storeKeys: storeKeys
  }), required ? ' *' : ''), _react["default"].createElement(_LocaleHelperText.ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }));
};