"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Select = void 0;
var _react = _interopRequireDefault(require("react"));
var _uiSchema = require("@ui-schema/ui-schema");
var _immutable = require("immutable");
var _LocaleHelperText = require("../../Component/LocaleHelperText/LocaleHelperText");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
var Select = exports.Select = function Select(_ref) {
  var schema = _ref.schema,
    storeKeys = _ref.storeKeys,
    showValidity = _ref.showValidity,
    errors = _ref.errors,
    value = _ref.value,
    _onChange = _ref.onChange,
    required = _ref.required;
  var enum_val = schema.get('enum');
  var _useUIMeta = (0, _uiSchema.useUIMeta)(),
    t = _useUIMeta.t;
  if (!enum_val) return null;
  if (!schema) return null;
  var classForm = ['selectpicker', 'custom-select'];
  var classFormParent = ['form-group'];
  if (showValidity && errors.hasError()) {
    classForm.push('is-invalid');
  }
  if (showValidity && !errors.hasError()) {
    classForm.push('was-validated');
  }
  var currentValue = typeof value !== 'undefined' ? value : schema.get('default') || '';
  return _react["default"].createElement("div", {
    className: classFormParent.join(' ')
  }, _react["default"].createElement("label", null, _react["default"].createElement(_uiSchema.TransTitle, {
    schema: schema,
    storeKeys: storeKeys
  })), _react["default"].createElement("select", {
    value: currentValue,
    className: classForm.join(' '),
    onChange: function onChange(e) {
      var target = e.target;
      _onChange({
        storeKeys: storeKeys,
        scopes: ['value'],
        type: 'update',
        updater: function updater() {
          return {
            value: target.value
          };
        },
        schema: schema,
        required: required
      });
    }
  }, enum_val ? enum_val.map(function (enum_name) {
    var s = enum_name + '';
    var Translated = t(s, (0, _immutable.Map)({
      relative: (0, _immutable.List)(['enum', s])
    }), schema.get('t'));
    return _react["default"].createElement("option", {
      key: enum_name,
      value: enum_name,
      defaultValue: currentValue === enum_name
    }, typeof Translated === 'string' || typeof Translated === 'number' ? Translated : (0, _uiSchema.beautifyKey)(s, schema.get('ttEnum')));
  }).valueSeq() : null), _react["default"].createElement(_LocaleHelperText.ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }));
};