"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectMulti = void 0;
var _react = _interopRequireDefault(require("react"));
var _uiSchema = require("@ui-schema/ui-schema");
var _immutable = require("immutable");
var _LocaleHelperText = require("../../Component/LocaleHelperText/LocaleHelperText");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var SelectMulti = exports.SelectMulti = (0, _uiSchema.extractValue)((0, _uiSchema.memo)(function (_ref) {
  var schema = _ref.schema,
    storeKeys = _ref.storeKeys,
    showValidity = _ref.showValidity,
    errors = _ref.errors,
    value = _ref.value,
    _onChange = _ref.onChange,
    required = _ref.required;
  var _useUIMeta = (0, _uiSchema.useUIMeta)(),
    t = _useUIMeta.t;
  if (!schema) return null;
  var oneOfValues = schema.getIn(['items', 'oneOf']);
  if (!oneOfValues) return null;
  var classForm = ['selectpicker', 'custom-select'];
  var classFormParent = ['form-group'];
  if (showValidity && errors.hasError()) {
    classForm.push('is-invalid');
  }
  if (showValidity && !errors.hasError()) {
    classForm.push('was-validated');
  }
  var currentValue = typeof value !== 'undefined' ? value : schema.get('default') ? (0, _immutable.List)(schema.get('default')) : (0, _immutable.List)([]);
  return _react["default"].createElement("div", {
    className: classFormParent.join(' ')
  }, _react["default"].createElement("label", null, _react["default"].createElement(_uiSchema.TransTitle, {
    schema: schema,
    storeKeys: storeKeys
  })), _react["default"].createElement("select", {
    value: currentValue.toArray(),
    className: classForm.join(' '),
    multiple: true,
    onChange: function onChange(e) {
      var target = e.target;
      _onChange({
        storeKeys: storeKeys,
        scopes: ['value'],
        type: 'update',
        updater: function updater() {
          return {
            value: (0, _uiSchema.sortScalarList)((0, _immutable.List)(_toConsumableArray(target.options).filter(function (o) {
              return o.selected;
            }).map(function (o) {
              return o.value;
            })))
          };
        },
        schema: schema,
        required: required
      });
    }
  }, oneOfValues ? oneOfValues.map(function (oneOfSchema) {
    var oneOfVal = oneOfSchema.get('const') + '';
    var Translated = t(oneOfVal, (0, _immutable.Map)({
      relative: (0, _immutable.List)(['title'])
    }), oneOfSchema.get('t'));
    return _react["default"].createElement("option", {
      key: oneOfVal,
      value: oneOfVal,
      defaultValue: currentValue.toArray().includes(oneOfVal)
    }, typeof Translated === 'string' || typeof Translated === 'number' ? Translated : (0, _uiSchema.beautifyKey)(oneOfVal, oneOfSchema.get('tt')));
  }).valueSeq() : null), _react["default"].createElement(_LocaleHelperText.ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }));
}));