"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.convertStringToNumber = exports.TextRenderer = exports.StringRenderer = exports.NumberRenderer = void 0;
var _react = _interopRequireDefault(require("react"));
var _uiSchema = require("@ui-schema/ui-schema");
var _LocaleHelperText = require("../../Component/LocaleHelperText/LocaleHelperText");
var _reactUid = require("react-uid");
var _excluded = ["schema"],
  _excluded2 = ["schema"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var convertStringToNumber = exports.convertStringToNumber = function convertStringToNumber(value, type) {
  if (type === 'number') {
    if (isNaN(value * 1)) {
      console.error('Invalid Type: input not a number in');
      return;
    }
    return value === '' ? '' : value * 1;
  }
  return value;
};
var StringRenderer = exports.StringRenderer = function StringRenderer(_ref) {
  var schema = _ref.schema,
    value = _ref.value,
    _ref$multiline = _ref.multiline,
    multiline = _ref$multiline === void 0 ? false : _ref$multiline,
    _onChange = _ref.onChange,
    storeKeys = _ref.storeKeys,
    showValidity = _ref.showValidity,
    required = _ref.required,
    errors = _ref.errors,
    type = _ref.type,
    rows = _ref.rows;
  var format = schema.get('format');
  var uid = (0, _reactUid.useUID)();
  var Renderer = 'input';
  if (multiline) {
    Renderer = 'textarea';
  }
  var classFormGroup = ['form-group'];
  var classFormControl = ['form-control'];
  if (showValidity && errors.hasError()) {
    classFormControl.push('is-invalid');
  }
  if (showValidity && !errors.hasError()) {
    classFormGroup.push('was-validated');
  }
  return _react["default"].createElement("div", {
    className: classFormGroup.join(' ')
  }, _react["default"].createElement("label", {
    htmlFor: 'uis-' + uid
  }, _react["default"].createElement(_uiSchema.TransTitle, {
    schema: schema,
    storeKeys: storeKeys
  })), _react["default"].createElement(Renderer, {
    className: classFormControl.join(' '),
    type: format || type,
    required: required,
    rows: rows,
    disabled: Boolean(schema === null || schema === void 0 ? void 0 : schema.get('readOnly')),
    value: typeof value !== 'undefined' ? value : '',
    onChange: function onChange(e) {
      var val = e.target.value;
      _onChange({
        storeKeys: storeKeys,
        scopes: ['value'],
        type: 'set',
        data: {
          value: convertStringToNumber(val, schema.get('type'))
        },
        schema: schema,
        required: required
      });
    }
  }), _react["default"].createElement(_LocaleHelperText.ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }));
};
var TextRenderer = exports.TextRenderer = function TextRenderer(_ref2) {
  var schema = _ref2.schema,
    props = _objectWithoutProperties(_ref2, _excluded);
  return _react["default"].createElement(StringRenderer, _extends({}, props, {
    schema: schema,
    rows: schema.getIn(['view', 'rows']),
    multiline: true
  }));
};
var NumberRenderer = exports.NumberRenderer = function NumberRenderer(_ref3) {
  var schema = _ref3.schema,
    props = _objectWithoutProperties(_ref3, _excluded2);
  return _react["default"].createElement(StringRenderer, _extends({}, props, {
    schema: schema,
    type: 'number'
  }));
};