import React from 'react';
import { useUID } from 'react-uid';
import { TransTitle } from '@ui-schema/ui-schema';
import { ValidityHelperText } from '../../Component/LocaleHelperText/LocaleHelperText';
const BoolRenderer = ({
  showValidity,
  required,
  errors,
  value,
  storeKeys,
  onChange,
  schema
}) => {
  const id = useUID();
  let classForm = ['custom-control', 'custom-switch'];
  let classLabel = ['custom-control-label', 'text-light'];
  let classFormControl = ['custom-control-input'];
  if (showValidity && errors.hasError()) {
    classFormControl.push('is-invalid');
  }
  if (showValidity && !errors.hasError()) {
    classForm.push('was-validated');
  }
  let currentChecked = !!value;
  return React.createElement("div", {
    className: classForm.join(' ')
  }, React.createElement("input", {
    type: "checkbox",
    className: classFormControl.join(' '),
    id: 'uis-' + id,
    checked: currentChecked,
    required: required,
    onChange: () => onChange({
      storeKeys,
      scopes: ['value'],
      type: 'update',
      updater: ({
        value: storeValue
      }) => ({
        value: !storeValue
      }),
      schema,
      required
    })
  }), React.createElement("label", {
    className: classLabel.join(' '),
    htmlFor: 'uis-' + id
  }, React.createElement(TransTitle, {
    schema: schema,
    storeKeys: storeKeys
  }), required ? ' *' : ''), React.createElement(ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }));
};
export { BoolRenderer };