import React from 'react';
import { TransTitle, extractValue, memo, PluginStack } from '@ui-schema/ui-schema';
import { List } from 'immutable';
import { ValidityHelperText } from '../../Component/LocaleHelperText/LocaleHelperText';
import { IconPlus, IconMinus } from '@ui-schema/ds-bootstrap/Component/Icons/Icons';
const SimpleList = extractValue(memo(({
  storeKeys,
  schema,
  value,
  onChange,
  showValidity,
  errors,
  required
}) => {
  let btnSize = schema.getIn(['view', 'btnSize']) || 'small';
  let classFormGroup = ['form-group', 'd-flex', 'align-items-center'];
  let classFormControl = ['form-control'];
  if (showValidity && errors.hasError()) {
    classFormControl.push('is-invalid');
  }
  if (showValidity && !errors.hasError()) {
    classFormGroup.push('was-validated');
  }
  return React.createElement(React.Fragment, null, React.createElement(TransTitle, {
    schema: schema,
    storeKeys: storeKeys
  }), React.createElement("div", null, value ? value.map((val, i) => React.createElement("div", {
    key: i,
    className: classFormGroup.join(' ')
  }, React.createElement(PluginStack, {
    className: classFormControl.join(' '),
    showValidity: showValidity,
    storeKeys: storeKeys.push(i),
    parentSchema: schema,
    schema: schema.get('items'),
    required: required,
    noGrid: true
  }), React.createElement("div", null, React.createElement(IconMinus, {
    btnSize: btnSize,
    onClick: () => {
      onChange({
        storeKeys,
        scopes: ['value'],
        type: 'update',
        updater: ({
          value: storeValue
        }) => ({
          value: storeValue.splice(i, 1)
        }),
        schema,
        required
      });
    }
  })))).valueSeq() : null, React.createElement("div", null, React.createElement(IconPlus, {
    btnSize: btnSize,
    onClick: () => {
      onChange({
        storeKeys,
        scopes: ['value'],
        type: 'update',
        updater: ({
          value: storeValue = List()
        }) => ({
          value: storeValue.push('')
        }),
        schema,
        required
      });
    }
  }))), React.createElement(ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }));
}));
export { SimpleList };