const _excluded = ["schema"],
  _excluded2 = ["schema"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { TransTitle } from '@ui-schema/ui-schema';
import { ValidityHelperText } from '../../Component/LocaleHelperText/LocaleHelperText';
import { useUID } from 'react-uid';
export const convertStringToNumber = (value, type) => {
  if (type === 'number') {
    if (isNaN(value * 1)) {
      console.error('Invalid Type: input not a number in');
      return;
    }
    return value === '' ? '' : value * 1;
  }
  return value;
};
const StringRenderer = ({
  schema,
  value,
  multiline = false,
  onChange,
  storeKeys,
  showValidity,
  required,
  errors,
  type,
  rows
}) => {
  const format = schema.get('format');
  const uid = useUID();
  let Renderer = 'input';
  if (multiline) {
    Renderer = 'textarea';
  }
  let classFormGroup = ['form-group'];
  let classFormControl = ['form-control'];
  if (showValidity && errors.hasError()) {
    classFormControl.push('is-invalid');
  }
  if (showValidity && !errors.hasError()) {
    classFormGroup.push('was-validated');
  }
  return React.createElement("div", {
    className: classFormGroup.join(' ')
  }, React.createElement("label", {
    htmlFor: 'uis-' + uid
  }, React.createElement(TransTitle, {
    schema: schema,
    storeKeys: storeKeys
  })), React.createElement(Renderer, {
    className: classFormControl.join(' '),
    type: format || type,
    required: required,
    rows: rows,
    disabled: Boolean(schema?.get('readOnly')),
    value: typeof value !== 'undefined' ? value : '',
    onChange: e => {
      const val = e.target.value;
      onChange({
        storeKeys,
        scopes: ['value'],
        type: 'set',
        data: {
          value: convertStringToNumber(val, schema.get('type'))
        },
        schema,
        required
      });
    }
  }), React.createElement(ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }));
};
const TextRenderer = _ref => {
  let {
      schema
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  return React.createElement(StringRenderer, _extends({}, props, {
    schema: schema,
    rows: schema.getIn(['view', 'rows']),
    multiline: true
  }));
};
const NumberRenderer = _ref2 => {
  let {
      schema
    } = _ref2,
    props = _objectWithoutProperties(_ref2, _excluded2);
  return React.createElement(StringRenderer, _extends({}, props, {
    schema: schema,
    type: 'number'
  }));
};
export { StringRenderer, NumberRenderer, TextRenderer };